Begin1:
li $t0, 0x80000000
or $t1, $0, $0   # $t1 is x
or $t2, $0, $0   # $t2 is y
ori $t3, $0, 267  # $t3 = 267
ori $t4, $0, 599  # $t4 = 599
ori $t5, $0, 0x07E0    # $t5 = GREEN
ori $t8, $0, 0xF800 # $t8 = RED
ori $t9, $0, 0x001F # $t9 = BLUE

Loop:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t5, 0($t7) # store GREEN
bne $t2, $t4, SkipZeroY
addiu $t2, $t2, 1   # always increment y (branch delay slot)
or $t2, $0, $0     #y=0
beq $t1, $t3, RED
addiu $t1, $t1, 1  #x++, always increment x in y overflow condition (branch delay slot)

SkipZeroY:
beq $0, $0, Loop
nop


RED:
ori $t3, $0, 534  # $t3 = 534
Loop2:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t8, 0($t7) # store RED
bne $t2, $t4, SkipZeroY2
addiu $t2, $t2, 1   # always increment y (branch delay slot)
or $t2, $0, $0     #y=0
beq $t1, $t3, BLUE
addiu $t1, $t1, 1  #x++, always increment x in y overflow condition (branch delay slot)

SkipZeroY2:
beq $0, $0, Loop2
nop

BLUE:
ori $t3, $0, 799  # $t3 = 799
Loop3:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t9, 0($t7) #  store BLUE
bne $t2, $t4, SkipZeroY3
addiu $t2, $t2, 1   # always increment y (branch delay slot)
or $t2, $0, $0     #y=0
beq $t1, $t3, Done
addiu $t1, $t1, 1  #x++, always increment x in y overflow condition (branch delay slot)

SkipZeroY3:
beq $0, $0, Loop3
nop


Done:
la $t0, 0xffff0000
TryW: # O
lw $t1, 8($t0)
nop
andi $t1, $t1, 0x1
beq $t1, $0, TryW
nop
ori $t2, $0, 79
sw $t2, 12($t0)

Try2:   # K
lw $t1, 8($t0)
nop
andi $t1, $t1, 0x1
beq $t1, $0, Try2
nop 
ori $t2 $0, 75
sw $t2, 12($t0)


# end vertical stripes

#begin waiting
li $t0, 25000000
addiu $t1, $0, 0
Spin:
bne $t1, $t0, Spin
addiu $t1, $t1, 1
#end waiting


#begin horizontal stripes




HBegin1:
li $t0, 0x80000000
or $t1, $0, $0   # $t1 is x
or $t2, $0, $0   # $t2 is y
ori $t3, $0, 799  # $t3 = 799
ori $t4, $0, 199  # $t4 = 199
ori $t5, $0, 0x07E0    # $t5 = GREEN
ori $t8, $0, 0xF800 # $t8 = RED
ori $t9, $0, 0x001F # $t9 = BLUE

HLoop:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t5, 0($t7) # store GREEN
bne $t1, $t3, HSkipZeroX
addiu $t1, $t1, 1   # always increment x (branch delay slot)
or $t1, $0, $0     #x=0
beq $t2, $t4, HRED
addiu $t2, $t2, 1  #y++, always increment y in x overflow condition (branch delay slot)

HSkipZeroX:
beq $0, $0, HLoop
nop


HRED:
ori $t4, $0, 399  # $t4 = 399
HLoop2:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t8, 0($t7) # store RED
bne $t1, $t3, HSkipZeroX2
addiu $t1, $t1, 1   # always increment x (branch delay slot)
or $t1, $0, $0     #x=0
beq $t2, $t4, HBLUE
addiu $t2, $t2, 1  #y++, always increment y in x overflow condition (branch delay slot)

HSkipZeroX2:
beq $0, $0, HLoop2
nop

HBLUE:
ori $t4, $0, 599  # $t4 = 599
HLoop3:
sll $t6, $t1, 2   # build address
sll $t7, $t2, 12  #
or $t7, $t7, $t6  #
or $t7, $t7, $t0  #
sw $t9, 0($t7) #  store BLUE
bne $t1, $t3, HSkipZeroX3
addiu $t1, $t1, 1   # always increment x (branch delay slot)
or $t1, $0, $0     #x=0
beq $t2, $t4, HDone
addiu $t2, $t2, 1  #y++, always increment y in x overflow condition (branch delay slot)

HSkipZeroX3:
beq $0, $0, HLoop3
nop


HDone:
la $t0, 0xffff0000


HTryW: # O
lw $t1, 8($t0)
nop
andi $t1, $t1, 0x1
beq $t1, $0, HTryW
nop
ori $t2, $0, 79
sw $t2, 12($t0)

HTry2:   # K
lw $t1, 8($t0)
nop
andi $t1, $t1, 0x1
beq $t1, $0, HTry2
nop
ori $t2 $0, 75
sw $t2, 12($t0)

#end horiz stripes

#begin waiting
li $t0, 25000000
addiu $t1, $0, 0
HSpin:
bne $t1, $t0, HSpin
addiu $t1, $t1, 1
#end waiting

# jump to vertical stripes
beq $0, $0, Begin1
nop
